const { merge } = require('webpack-merge')
const common = require('./webpack.common.js')

const structure = require('./.webpack.structure.js')
let pages = []
for( let [key, items] of Object.entries( structure )) {
  if( items.page == true ) pages.push( key )
}

module.exports = merge(common, {

  mode: 'development',

  devtool: 'source-map',
  devServer: {
    static: './test',
    devMiddleware: { 
      writeToDisk: true 
    }
  },  
  infrastructureLogging: {
    level: 'warn',
  },
})